SystemOrganization addCategory: #'Magritte-Seaside-Components'!
SystemOrganization addCategory: #'Magritte-Seaside-Renderer'!
SystemOrganization addCategory: #'Magritte-Seaside-Examples'!

!MAOptions class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/11/2005 23:22'!
defaultComponentClass
	^MASelectListComponent! !

!MAText class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATextAreaComponent! !

!MAContainer class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:34'!
defaultComponentClass
	^MAContainerComponent! !

!MAContainer methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:09'!
acceptRenderer: aRenderer
	aRenderer renderContainer: self.! !

WAComponent subclass: #MAComponent
	instanceVariableNames: 'model description renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAComponent class methodsFor: 'accessing-defaults' stamp: 'lr 3/14/2005 17:02'!
defaultRenderer
	^MATableRenderer new.! !

!MAComponent class methodsFor: 'class initialization' stamp: 'lr 3/11/2005 15:49'!
initialize
	Sentinel := Object new.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 11/28/2004 19:10'!
model: aModel
	^self model: aModel description: aModel description.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 12/20/2004 20:20'!
model: aModel description: aDescription
	^self model: aModel description: aDescription renderer: self defaultRenderer.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 12/20/2004 18:25'!
model: aModel description: aDescription renderer: aRenderer
	^self new
		model: aModel;
		description: aDescription;
		renderer: aRenderer;
		yourself.! !

!MAComponent methodsFor: 'forms' stamp: 'lr 2/28/2005 16:14'!
addForm
	self addForm: #( save cancel ).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 2/28/2005 16:14'!
addForm: aCollection
	self addDecoration: (WAFormDecoration new 
		buttons: aCollection;
		yourself).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 3/14/2005 11:58'!
addValidatedForm
	self addValidatedForm: #( save cancel ).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 3/14/2005 12:09'!
addValidatedForm: aCollection
	self addDecoration: (WAFormDecoration new 
		buttons: aCollection;
		yourself).
	self addDecoration: (MAValidationDecoration new).! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:08'!
buildComponent: anObject
	^self 
		buildComponent: anObject 
		description: anObject description.! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:27'!
buildComponent: anObject description: aDescription
	^(aDescription asComponentOn: anObject)
		renderer: self renderer;
		yourself.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
cancel
	self answer: nil.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/11/2005 11:46'!
close
	self cancel.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/11/2005 15:44'!
commit! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
description
	^description! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
description: anObject
	description := anObject! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
model
	^model! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
model: anObject
	model := anObject! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 20:40'!
readonly
	^self renderer readonly.! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 23:00'!
readonly: aBoolean
	self renderer readonly: aBoolean.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
refresh! !

!MAComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:13'!
renderContentOn: html
	self renderer
		component: self;
		html: html;
		visit: self description.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 22:29'!
renderEditorOn: html 
	self renderViewerOn: html.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 17:08'!
renderLabelOn: html
	self description label isEmptyOrNil ifFalse: [
		html render: self description label; text: ':' ].
	self renderRequiredOn: html.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 17:07'!
renderRequiredOn: html 
	(self description isRequired and: [ self description isReadonly not ])
		ifTrue: [ html spanClass: 'required' with: '*' ].! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/3/2005 15:18'!
renderViewerOn: html 
	html render: self cache.! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/3/2005 16:16'!
renderer
	^renderer! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:08'!
renderer: aRenderer
	renderer := aRenderer! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
reset! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 12:17'!
save
	self validate; commit; answer: self model.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
validate! !

MAComponent subclass: #MAContainerComponent
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAContainerComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:32'!
buildChildren
	^Array streamContents: [ :stream |
		self description do: [ :each |
			each isVisible ifTrue: [
				stream nextPut: (self
					buildComponent: self model 
					description: each) ] ] ].! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:31'!
children
	children isNil
		ifTrue: [ self children: self buildChildren ].
	^children.! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:06'!
children: aCollection
	children := aCollection! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/15/2005 22:51'!
commit
	self children do: [ :each | each commit ].
	super commit.! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:06'!
refresh
	super refresh.
	self children: nil.! !

!MAContainerComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:48'!
renderViewerOn: html 
	self children do: [ :each | html render: each ].! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:02'!
reset
	super reset.
	self children do: [ :each | each reset ].
! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:02'!
validate
	super validate.
	self children do: [ :each | each validate ].! !

MAComponent subclass: #MAElementComponent
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MAElementComponent subclass: #MACheckboxComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MACheckboxComponent methodsFor: 'private' stamp: 'lr 3/14/2005 17:06'!
renderCheckboxDisabled: aBoolean on: html
	html label: [
		html attributeAt: 'disabled' put: aBoolean.
		html checkboxOn: #cache of: self. 
		html render: self description label ].! !

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/14/2005 17:06'!
renderEditorOn: html
	self renderCheckboxDisabled: false on: html.
	self renderRequiredOn: html.! !

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:07'!
renderLabelOn: html! !

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/14/2005 14:45'!
renderViewerOn: html
	self renderCheckboxDisabled: true on: html.! !

!MAElementComponent methodsFor: 'private' stamp: 'lr 3/15/2005 22:56'!
buildCache
	^self description read: self model.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/12/2005 00:07'!
cache
	cache isNil
		ifTrue: [ self cache: self buildCache ].
	^cache.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/14/2005 16:24'!
cache: anObject
	cache := anObject isString
		ifTrue: [ self description parseString: anObject ]
		ifFalse: [ anObject ].! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 16:24'!
commit
	super commit.
	self description isReadonly 
		ifFalse: [ self description write: cache to: model ].! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/13/2005 17:29'!
reset
	super reset.
	self cache: nil.! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 16:25'!
validate
	super validate.
	self description isReadonly 
		ifFalse: [ self description validate: cache ].! !

MAElementComponent subclass: #MAFileUploadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 3/14/2005 17:07'!
renderEditorOn: html 
	html attributes: self description attributes.
	html fileUploadWithCallback: [ :file | self cache: file ].! !

MAElementComponent subclass: #MARadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MARadioGroupComponent methodsFor: 'rendering' stamp: 'lr 3/11/2005 23:22'!
renderEditorOn: html
	html radioGroup in: [ :group |
		self description options do: [ :each |
			html label: [
				html attributes: self description attributes.
				html 
					radioButtonInGroup: group
					selected: self cache = each
					callback: [ self cache: each ].
				html render: each ] ] ].! !

MAElementComponent subclass: #MASelectListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MASelectListComponent methodsFor: 'rendering' stamp: 'lr 3/16/2005 15:32'!
renderEditorOn: html
	html attributes: self description attributes.
	html 
		selectFromList: self description options
		selected: self cache
		callback: (MessageSend
			receiver: self
			selector: #cache:)
		labels: [ :each | each asLabel ].! !

MAElementComponent subclass: #MATableComponent
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATableComponent methodsFor: 'private' stamp: 'lr 3/15/2005 22:21'!
buildCache
	^(self description read: self model) in: [ :result |
		self fieldCount = result size
			ifFalse: [ Array new: self fieldCount ]
			ifTrue: [ result copy ] ].! !

!MATableComponent methodsFor: 'private' stamp: 'lr 3/16/2005 20:28'!
buildCells
	^self cache collectWithIndex: [ :each :index |
		self description cellDescription copy
			key: index; 
			label: (String streamContents: [ :stream |
				stream 
					nextPutAll: self description label;
					nextPutAll: ' [';
					nextPutAll: (self columnLabels at: (self columnOfIndex: index)); 
					nextPutAll: ', ';
					nextPutAll: (self rowLabels at: (self rowOfIndex: index));
					nextPutAll: ']' ]);
			asComponentOn: self ].	! !

!MATableComponent methodsFor: 'accessing-table' stamp: 'lr 3/15/2005 22:07'!
cacheAt: aRowIndex at: aColIndex
	^self cache at: (self indexAt: aRowIndex at: aColIndex).! !

!MATableComponent methodsFor: 'accessing-table' stamp: 'lr 3/15/2005 22:08'!
cacheAt: aRowIndex at: aColIndex put: anObject
	self cache at: (self indexAt: aRowIndex at: aColIndex) put: anObject.! !

!MATableComponent methodsFor: 'accessing-table' stamp: 'lr 3/15/2005 22:47'!
cellAt: aRowIndex at: aColIndex
	^self cells at: (self indexAt: aRowIndex at: aColIndex).! !

!MATableComponent methodsFor: 'accessing-table' stamp: 'lr 3/15/2005 22:47'!
cellAt: aRowIndex at: aColIndex put: aComponent
	self cells at: (self indexAt: aRowIndex at: aColIndex) put: aComponent.! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:48'!
cells
	cells isNil
		ifTrue: [ self cells: self buildCells ].
	^cells.! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:48'!
cells: aColleciton
	cells := aColleciton! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:11'!
columnCount
	^self description columnCount.! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:32'!
columnLabels
	^self description columnLabels.! !

!MATableComponent methodsFor: 'private-indexes' stamp: 'lr 3/15/2005 23:14'!
columnOfIndex: anInteger
	| index |
	index := anInteger \\ self columnCount.
	^index isZero
		ifTrue: [ self columnCount ]
		ifFalse: [ index ].! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 3/15/2005 22:51'!
commit
	self cells do: [ :each | each commit ].
	super commit.! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:18'!
fieldCount
	^self rowCount * self columnCount.! !

!MATableComponent methodsFor: 'private-indexes' stamp: 'lr 3/15/2005 23:08'!
indexAt: aRowIndex at: aColIndex
	^aRowIndex - 1 * self columnCount + aColIndex.! !

!MATableComponent methodsFor: 'private-model' stamp: 'lr 3/15/2005 22:41'!
readUsing: aDescription
	^self cache at: aDescription key.! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 3/15/2005 22:59'!
renderEditorOn: html
	self 
		renderTableCells: [ :cell | cell renderEditorOn: html ]
		on: html.! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 3/15/2005 22:59'!
renderTableCells: aBlock on: html
	html table: [
		html tableRow: [
			html tableHeading: nil.
			self columnLabels do: [ :each |
				html tableHeading: each ] ].
		self rowLabels withIndexDo: [ :row :rindex |
			html tableRow: [
				html tableHeading: row.
				self columnLabels withIndexDo: [ :col :cindex |
					html tableData: [ 
						aBlock value: (self cellAt: rindex at: cindex) ] ] ] ] ].! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 3/15/2005 22:59'!
renderViewerOn: html
	self 
		renderTableCells: [ :cell | cell renderViewerOn: html ]
		on: html.! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 3/15/2005 22:50'!
reset
	super reset.
	self cells: nil.! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:11'!
rowCount
	^self description rowCount.! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:32'!
rowLabels
	^self description rowLabels.! !

!MATableComponent methodsFor: 'private-indexes' stamp: 'lr 3/15/2005 23:15'!
rowOfIndex: anInteger
	^anInteger - 1 // self columnCount + 1.! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 3/15/2005 22:51'!
validate
	super validate.
	self cells do: [ :each | each validate ].! !

!MATableComponent methodsFor: 'private-model' stamp: 'lr 3/15/2005 22:52'!
write: anObject using: aDescription
	^self cache at: aDescription key put: anObject.! !

MAElementComponent subclass: #MATextAreaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:17'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textAreaOn: #cache of: self.! !

MAElementComponent subclass: #MATextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MATextInputComponent subclass: #MADateInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 3/14/2005 16:26'!
renderEditorOn: html
	super renderEditorOn: html.
	html 
		submitButtonWithAction: [ self cache: Date current ]
		text: 'current'.! !

MATextInputComponent subclass: #MADurationInputComponent
	instanceVariableNames: 'start'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADurationInputComponent methodsFor: 'rendering' stamp: 'lr 3/15/2005 21:55'!
renderEditorOn: html
	super renderEditorOn: html.
	html
		submitButtonWithAction: [  
			start isNil
				ifTrue: [ start := TimeStamp current ]
				ifFalse: [ self cache: TimeStamp current - start. start := nil ] ]
		text: (start isNil ifTrue: [ 'start' ] ifFalse: [ 'stop' ]).! !

!MATextInputComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:33'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textInputOn: #cache of: self.! !

MATextInputComponent subclass: #MATimeInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeInputComponent methodsFor: 'rendering' stamp: 'lr 3/12/2005 00:05'!
renderEditorOn: html
	super renderEditorOn: html.
	html 
		submitButtonWithAction: [ self cache: Time current ]
		text: 'current'.! !

MATextInputComponent subclass: #MATimeStampInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeStampInputComponent methodsFor: 'rendering' stamp: 'lr 3/12/2005 00:05'!
renderEditorOn: html
	super renderEditorOn: html.
	html 
		submitButtonWithAction: [ self cache: TimeStamp current ]
		text: 'current'.! !

MAElementComponent subclass: #MATextPasswordComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextPasswordComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 14:09'!
commit
	(self description isObfuscated: self cache)
		ifFalse: [ super commit ].! !

!MATextPasswordComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 16:27'!
obfuscated
	^String 
		new: (self cache isNil 
			ifTrue: [ 0 ]
			ifFalse: [ self cache size ])
		withAll: $*.! !

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:25'!
renderEditorOn: html 
	html attributes: self description attributes.
	html 
		passwordInputWithValue: self obfuscated
		callback: (MessageSend 
			receiver: self 
			selector: #cache:).! !

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:24'!
renderViewerOn: html 
	html render: self obfuscated.! !

WAComponent subclass: #MAMockComponent
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MAMockComponent class methodsFor: 'class initialization' stamp: 'lr 3/10/2005 15:12'!
initialize
	self registerAsApplication: 'magritte'.! !

!MAMockComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 12:13'!
editDescription: aDescription
	^self call: (aDescription asComponent 
		addValidatedForm;
		yourself).! !

!MAMockComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 12:14'!
editModel
	^self call: (self model asComponent 
		addValidatedForm;
		yourself).! !

!MAMockComponent methodsFor: 'initialization' stamp: 'lr 3/14/2005 12:20'!
initialize
	super initialize.
	self addDecoration: MAMockDecoration new.! !

!MAMockComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 15:02'!
model
	model isNil
		ifTrue: [ self model: MAMockModel new ].
	^model.! !

!MAMockComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 15:02'!
model: aModel
	model := aModel! !

!MAMockComponent methodsFor: 'rendering' stamp: 'lr 3/14/2005 16:54'!
renderContentOn: html
	html 
		anchorWithCallback: [ self editModel ]
		do: 'edit model'.
	html text: ' '.
	html
		anchorWithCallback: [ self showModel ]
		do: 'show model'.  
	html layoutTable: [
		html tableRow: [
			html tableHeading: 'Key'.
			html tableHeading: 'Label'.
			html tableHeading: 'Priority'.
			html tableHeading: 'Default'.
			html tableHeading: 'Visibility'.
			html tableHeading: 'Readonly'.
			html tableHeading: 'Required'.
			html tableHeading: nil ].
		self model description do: [ :each |
			html tableRow: [
				html tableData: each key.
				html tableData: each label.
				html tableData: each priority.
				html tableData: each default.
				html tableData: each visible.
				html tableData: each readonly.
				html tableData: each required.
				html tableData: [
					html 
						anchorWithAction: [ self editDescription: each ]
						do: 'edit'.
					html space.
					html 
						anchorWithAction: [ self showDescription: each ]
						do: 'view' ] ] ] ].! !

!MAMockComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 12:14'!
showDescription: aDescription
	^self call: (aDescription asComponent 
		addForm: #( close ); 
		readonly: true; 
		yourself).! !

!MAMockComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 12:14'!
showModel
	self call: (self model asComponent 
		addForm: #( close ); 
		readonly: true; 
		yourself).! !

Object subclass: #MARenderer
	instanceVariableNames: 'html component readonly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

MARenderer subclass: #MACssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MACssRenderer methodsFor: 'private' stamp: 'lr 3/14/2005 14:20'!
cssClass: aString modificators: aDescription
	^String streamContents: [ :stream |
		stream nextPutAll: aString.
		aDescription isReadonly
			ifTrue: [ stream space; nextPutAll: 'readonly' ].
		aDescription isRequired
			ifTrue: [ stream space; nextPutAll: 'required' ] ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:51'!
renderContainer: aDescription
	html divClass: 'container' with: [ super renderContainer: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 14:23'!
renderEditor: aDescription
	html 
		divClass: 'editor'
		with: [ super renderEditor: aDescription ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/14/2005 14:37'!
renderElement: aDescription
	html 
		divClass: (self cssClass: 'element' modificators: aDescription)
		with: [ super renderElement: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 14:23'!
renderLabel: aDescription
	html 
		divClass: 'label'
		with: [ super renderLabel: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 14:38'!
renderSpacer: aDescription
	html divClass: 'spacer' with: nil.! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 14:23'!
renderViewer: aDescription
	html 
		divClass: 'viewer'
		with: [ super renderViewer: aDescription ].! !

!MARenderer class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 21:02'!
in: aComponent on: aRenderer
	^self new
		component: aComponent;
		html: aRenderer;
		yourself.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
component
	^component! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
component: aComponent
	component := aComponent! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
html
	^html! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
html: aRenderer
	html := aRenderer! !

!MARenderer methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 22:13'!
initialize
	super initialize.
	self readonly: false.! !

!MARenderer methodsFor: 'testing' stamp: 'lr 3/10/2005 21:18'!
isReadonly
	^self readonly.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:17'!
readonly
	^readonly! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:17'!
readonly: aBoolean
	readonly := aBoolean! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:50'!
renderContainer: aDescription
	self renderWidget: aDescription.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:17'!
renderEditor: aDescription
	self component renderEditorOn: html.! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/14/2005 14:37'!
renderElement: aDescription
	self renderLabel: aDescription.
	self renderSpacer: aDescription.
	self renderWidget: aDescription.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/13/2005 18:06'!
renderLabel: aDescription
	self component renderLabelOn: html.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 14:37'!
renderSpacer: aDescription! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:17'!
renderViewer: aDescription
	self component renderViewerOn: html.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:51'!
renderWidget: aDescription
	(self isReadonly or: [ aDescription isReadonly ])
		ifTrue: [ self renderViewer: aDescription ]
		ifFalse: [ self renderEditor: aDescription ].! !

!MARenderer methodsFor: 'visiting' stamp: 'lr 3/10/2005 22:12'!
visit: aDescription
	aDescription acceptRenderer: self.! !

MARenderer subclass: #MATableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:55'!
renderContainer: aDescription
	html table: [ super renderWidget: aDescription ].
! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:28'!
renderElement: aDescription
	html tableRow: [ super renderElement: aDescription ].
! !

!MATableRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:22'!
renderLabel: aDescription
	html tableHeading: [ super renderLabel: aDescription ].! !

!MATableRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:30'!
renderWidget: aDescription
	html tableData: [ super renderWidget: aDescription ].! !

!Object methodsFor: '*Magritte-Seaside' stamp: 'lr 3/15/2005 15:55'!
asComponent
	"Return a generic Seaside component of the receiver."

	^self description asComponentOn: self.! !

!MABoolean class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 22:45'!
defaultComponentClass
	^MACheckboxComponent! !

!MATime class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATimeInputComponent! !

!MABinary class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:35'!
defaultComponentClass
	^MAFileUploadComponent! !

!MAElement class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:31'!
defaultAttributes
	^Dictionary new.! !

!MAElement methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:10'!
acceptRenderer: aRenderer
	aRenderer renderElement: self.! !

!MAElement methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:32'!
attributes
	^self 
		propertyAt: #attributes 
		ifAbsent: [ self class defaultAttributes ].! !

!MAElement methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
attributes: aDictionary
	^self propertyAt: #attributes put: aDictionary.! !

!MADuration class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/15/2005 21:49'!
defaultComponentClass
	^MADurationInputComponent! !

!MANumber class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MATextInputComponent! !

!MADate class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MADateInputComponent! !

!MAString class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MATextInputComponent! !

!MATable class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/15/2005 09:00'!
defaultComponentClass
	^MATableComponent! !

!MADescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 22:25'!
defaultComponentClass
	self subclassResponsibility! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:05'!
acceptRenderer: aRenderer
	self subclassResponsibility.! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/9/2005 22:28'!
asComponentOn: anObject
	^self componentClass model: anObject description: self.! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
componentClass
	^self propertyAt: #componentClass ifAbsent: [ self class defaultComponentClass ].! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
componentClass: aClass
	^self propertyAt: #componentClass put: aClass.! !

WADecoration subclass: #MAMockDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MAMockDecoration methodsFor: 'testing' stamp: 'lr 3/14/2005 12:19'!
isGlobal
	^true! !

!MAMockDecoration methodsFor: 'accessing' stamp: 'lr 3/14/2005 19:22'!
style
	^'body { font-family: Veranda, Arial, Helvetica; font-size: 12px; }
th { text-align: left; padding-right: 10px; }

.exception { color: red; }
.required { padding-left: 10px; color: red; }'.! !

WADecoration subclass: #MAValidationDecoration
	instanceVariableNames: 'exceptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 3/13/2005 17:50'!
exceptions
	^exceptions! !

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 3/11/2005 17:17'!
exceptions: aCollection
	exceptions := aCollection! !

!MAValidationDecoration methodsFor: 'testing' stamp: 'lr 3/13/2005 20:05'!
hasExceptions
	^self exceptions isEmptyOrNil not.! !

!MAValidationDecoration methodsFor: 'initialization' stamp: 'lr 3/14/2005 16:53'!
initialize
	super initialize.
	self exceptions: Array new.! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 3/13/2005 17:48'!
processChildCallbacks: aStream
	self wrapInValidationHandlerDo: [ super processChildCallbacks: aStream ].! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 3/14/2005 16:46'!
renderContentOn: html
	self hasExceptions
		ifTrue: [ self renderExceptionsOn: html ].
	self renderOwnerOn: html.! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 3/14/2005 16:55'!
renderExceptionsOn: html
	html divClass: 'exceptions' with: [
		self exceptions do: [ :each |
			html divClass: 'exception' with: each messageText ] ].
	self exceptions: Array new.! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 3/14/2005 16:53'!
wrapInValidationHandlerDo: aBlock
	aBlock
		on: MAError
		do: [ :error | 
			self exceptions: (self exceptions copyWith: error).
			error isResumeable ifTrue: [ error resume ] ].! !

!MAPassword class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATextPasswordComponent! !

!MATimeStamp class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/11/2005 23:05'!
defaultComponentClass
	^MATimeStampInputComponent! !
MAComponent initialize!
MAMockComponent initialize!
